Bug 1685226 - Review Request: gnatcoll-core - The GNAT Components Collection – core packages
Summary: Review Request: gnatcoll-core - The GNAT Components Collection – core packages
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1689552
TreeView+ depends on / blocked
 
Reported: 2019-03-04 17:33 UTC by Björn Persson
Modified: 2019-03-19 10:50 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-03-19 10:50:00 UTC


Attachments (Terms of Use)

Description Björn Persson 2019-03-04 17:33:33 UTC
Spec URL: https://www.rombobjörn.se/packages/gnatcoll-core-2018-1/gnatcoll-core.spec
SRPM URL: https://www.rombobjörn.se/packages/gnatcoll-core-2018-1/gnatcoll-core-2018-1.fc30.src.rpm

This is the first of three packages to replace the current gnatcoll package – the core module.

The GNAT Components Collection is a library of general-purpose packages that
are part of the GNAT technology. The components complement the predefined Ada
and GNAT libraries and deal with a range of common programming issues
including string and text processing, memory management, and file handling.

I'm not yet sure about the directory layout. I may find that I need to
move some files when I make the other packages.

Fedora Account System Username: rombobeorn

Comment 1 Robert-André Mauchin 2019-03-05 00:04:13 UTC
 - Split this on multiple line:

make install-relocatable 'prefix=%{buildroot}%{_prefix} --sources-subdir=%{buildroot}%{_includedir}/%{name} --lib-subdir=%{buildroot}%{_libdir} --ali-subdir=%{buildroot}%{_libdir}/%{name} --no-lib-link -m'

 - Split the doc into its own noarch subpackage

 - Please include all licenses you package, and add a comment explaining the license breakdown:

*No copyright* Creative Commons Attribution Public License (v3.0)
-----------------------------------------------------------------
gnatcoll-core-gpl-2018-src/src/getRSS.c

BSD (unspecified)
-----------------
gnatcoll-core-gpl-2018-src/docs/_build/html/_static/basic.css
gnatcoll-core-gpl-2018-src/docs/_build/html/_static/doctools.js
gnatcoll-core-gpl-2018-src/docs/_build/html/_static/searchtools.js
gnatcoll-core-gpl-2018-src/docs/_build/html/_static/sphinxdoc.css
gnatcoll-core-gpl-2018-src/docs/_build/html/_static/websupport.js

Expat License
-------------
gnatcoll-core-gpl-2018-src/docs/_build/html/_static/jquery-1.11.1.js

 - [!]: Uses parallel make %{?_smp_mflags} macro.

Add %{?_smp_mflags} to make? If it supports it.

 - This description line should be split to stay below 80 characters per line:

gnatcoll-core-devel.x86_64: E: description-line-too-long sv Paketet gnatcoll-core-devel innehåller källkod och länkningsinformation som behövs




Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Large documentation must go in a -doc subpackage. Large could be size
  (~1MB) or number of files.
  Note: Documentation size is 1925120 bytes in 98 files.
  See:
  http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL (v2 or later) (with incorrect FSF address)", "BSD
     (unspecified)", "Expat License", "Unknown or generated", "*No
     copyright* Creative Commons Attribution Public License (v3.0)". 637
     files have unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/gnatcoll-core/review-gnatcoll-
     core/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by:
     /usr/share/doc/gnatcoll(gnatcoll, gnatcoll-devel),
     /usr/share/doc/gnatcoll/html(gnatcoll-devel)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     gnatcoll-core-debuginfo , gnatcoll-core-debugsource
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 1966080 bytes in /usr/share
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: gnatcoll-core-2018-1.fc31.x86_64.rpm
          gnatcoll-core-devel-2018-1.fc31.x86_64.rpm
          gnatcoll-core-debuginfo-2018-1.fc31.x86_64.rpm
          gnatcoll-core-debugsource-2018-1.fc31.x86_64.rpm
          gnatcoll-core-2018-1.fc31.src.rpm
gnatcoll-core.x86_64: I: enchant-dictionary-not-found sv
gnatcoll-core.x86_64: W: no-documentation
gnatcoll-core-devel.x86_64: E: description-line-too-long sv Paketet gnatcoll-core-devel innehåller källkod och länkningsinformation som behövs
gnatcoll-core-devel.x86_64: W: hidden-file-or-dir /usr/share/doc/gnatcoll/examples/library/.gnatdebug
5 packages and 0 specfiles checked; 1 errors, 2 warnings.

Comment 2 Pavel Zhukov 2019-03-05 05:57:29 UTC
Gnatcoll 2018 is gnatcoll-core-2018. I'd prefer to add Provides: gnatcoll-core tag and package another libraries.

Comment 3 Björn Persson 2019-03-05 23:16:14 UTC
(In reply to Pavel Zhukov from comment #2)
> Gnatcoll 2018 is gnatcoll-core-2018. I'd prefer to add Provides:
> gnatcoll-core tag and package another libraries.

That can also be made to work with some extra trouble. The package named gnatcoll will need to pull in gnatcoll-bindings and gnatcoll-db, and gnatcoll-devel will need to pull in gnatcoll-bindings-devel and gnatcoll-db-devel. Otherwise functionality will mysteriously disappear when users upgrade. But that creates cyclical build-time dependencies because building gnatcoll-bindings and gnatcoll-db requires gnatcoll-core. The dependencies that are needed for upgrades will have to be temporarily removed for mass rebuilds. Adding gnatcoll-core as a new package avoids the cyclical dependencies. gnatcoll and gnatcoll-devel will then be empty packages that exist only to pull in gnatcoll-bindings and gnatcoll-db during upgrades.

I also think it will be less confusing to users, as the name gnatcoll-core communicates clearly that it's not all of Gnatcoll but only the core.


(In reply to Robert-André Mauchin from comment #1)
>  - Split the doc into its own noarch subpackage

That's a good idea. Thanks.

>  - Please include all licenses you package, and add a comment explaining the
> license breakdown:

I'm afraid I forgot to check the licenses of the files from Sphinx. I'll make sure to fix that.

> Add %{?_smp_mflags} to make? If it supports it.

Parallel building is done by GPRbuild. The makefile just composes parameters to GPRbuild and GPRinstall.

Comment 4 Vratislav Podzimek 2019-03-13 12:06:52 UTC
> I also think it will be less confusing to users, as the name gnatcoll-core communicates clearly that it's not all of Gnatcoll but only the core.

I totally agree. And a clean upgrade path is critical, especially for stable releases.

Comment 5 Björn Persson 2019-03-19 10:50:00 UTC
We decided to make the source package gnatcoll produce gnatcoll-core subpackages, and also produce metapackages from the same source package to secure the upgrade path. Thus this review isn't needed. Thanks anyway, Robert-André. The issues you pointed out are fixed in the upgraded gnatcoll package.


Note You need to log in before you can comment on or make changes to this bug.